import 'package:plotter/models/settings/settings_global.dart';
import 'package:plotter/utils/tools.dart';

class Activity {
  Activity({
    // Settings
    required this.globalSettings,

    // State
    this.isRunning = false,

    // Base data
    this.apiHost = '',

    // Activity data
    this.apiStatus = '',
  });

  // Settings
  final GlobalSettings globalSettings;

  // State
  bool isRunning;

  // Base data
  String apiHost;

  // Activity data
  String apiStatus;

  factory Activity.createNull() {
    return Activity(
      // Settings
      globalSettings: GlobalSettings.createDefault(),
      // Base data
      apiHost: '',
    );
  }

  factory Activity.createNew({
    GlobalSettings? globalSettings,
  }) {
    final GlobalSettings newGlobalSettings = globalSettings ?? GlobalSettings.createDefault();

    return Activity(
      // Settings
      globalSettings: newGlobalSettings,
      // State
      isRunning: true,
      // Base data
      apiHost: '',
    );
  }

  void dump() {
    printlog('');
    printlog('## Current activity dump:');
    printlog('');
    printlog('$Activity:');
    printlog('  Settings');
    globalSettings.dump();
    printlog('  State');
    printlog('    isRunning: $isRunning');
    printlog('  Base data');
    printlog('    apiHost: $apiHost');
    printlog('  Activity data');
    printlog('    apiStatus: $apiStatus');
    printlog('');
  }

  @override
  String toString() {
    return '$Activity(${toJson()})';
  }

  Map<String, dynamic>? toJson() {
    return <String, dynamic>{
      // Settings
      'globalSettings': globalSettings.toJson(),
      // State
      'isRunning': isRunning,
      // Base data
      'apiHost': apiHost,
      // Activity data
      'apiStatus': apiStatus,
    };
  }
}
